//
//  Simulation.m
//  Evolution
//
//  Created by Ivo Npflin.
//  Copyright (c) 2004 evo.naepflin.com. All rights reserved.
//

#import "Simulation.h"
#import "Controller.h"
#import "Tier.h"
#import "Feld.h"

@implementation Simulation

NSMutableArray *Tiere; 
NSMutableArray *Felder; 
BOOL prozessLauf;
int AnzahlFelderX;
int AnzahlFelderY;
int Rand;
int r, s, t, u, v, w, i, z;
int ProzessZaehler;
//Steuerfunktionen
- (id)init
{
	Tiere = [[NSMutableArray alloc] init];
	//Tiere = [Tiere retain];
	Felder = [[NSMutableArray alloc] init];
	int ProzessZaehler = 0;
			
// Felder erstellen
	AnzahlFelderX = 10;	//Feldgrsse
	AnzahlFelderY = 10;
	AnzahlFelderX--;
	AnzahlFelderY--;
	

	for (r = 0; r <= AnzahlFelderX; r++)
	{
		NSMutableArray *Reihe = [[NSMutableArray alloc] init];
		for (s = 0; s <= AnzahlFelderY; s++)
			{
				if (r == 0 || r == AnzahlFelderX || s == 0 || s == AnzahlFelderY)
				{
					[Reihe addObject:[[Feld alloc] initAmRand:YES]];
				}
				else
				{
					[Reihe addObject:[[Feld alloc] initAmRand:NO]];
				}
			}
		[Felder addObject:Reihe];
		[Reihe release];
	}
	
	srand([[NSDate date] timeIntervalSince1970]);   //fr zufllige Zufallswerte ntig
	rand(); rand(); rand();
	
	return self;
} 

- (id)starten:(id)sender
{
    NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
	
	prozessLauf = YES;
		
//Prozess
	while (prozessLauf)
	{
	//Alle Tiere bewegen
		for (z = 0; z < [Tiere count]; z++)
		{
			[self ZugController:z];
		//soll: Statistiken knnten hier noch gemacht werden.
		}
		
	//Alle Felder wachsen
		for (t = 0; t < AnzahlFelderX; t++)
		{
			NSMutableArray *Reihe;
			Reihe = [Felder objectAtIndex:t];

			for (u = 0; u < AnzahlFelderY; u++)
				{
					[[Reihe objectAtIndex:u] Wachsen];
				}
		}
		
		if ([Tiere count] < 200 && [Tiere count] > 195)		//Wenn nur noch 200 Tiere da sind: stoppen, um auszuwerten
		{													//Um trotzdem die Tiere ganz aussterben zu lassen wird das Anhalten bei 195 gestoppt
			NSBeep();
			[myController Stop:self];
		}

		if ([Tiere count] < 1)		//Wenn keine Tiere mehr da sind: stoppen, um Endlosschleife zu vermeiden
		{
			NSBeep();
			[myController Stop:self];
		}
	
		ProzessZaehler++;

	}
	
	[pool release];
	
	return self;
}

- (id)anzeigen:(id)sender
{
			//soll ???
	return self;
}

- (id)stoppen:(id)sender
{
	prozessLauf = NO;
	return self;
}


//Prozessfunktionen
- (id)ZugController:(int)TierID
{
	id gewaehltesTier = [Tiere objectAtIndex:TierID];
	int StandortX = [gewaehltesTier StandortX];
	int StandortY = [gewaehltesTier StandortY];
	
	[gewaehltesTier Altern];
//Energie fr Leben
	[gewaehltesTier Energieabnahme:(float)[gewaehltesTier Nahrung1Anpassung]/25.000]; //soll etwa 20 geben
	[gewaehltesTier Energieabnahme:(float)[gewaehltesTier Nahrung2Anpassung]/25.000]; //soll etwa 20 geben

	if([gewaehltesTier Energiestand] < 0 || [gewaehltesTier Alter] > 200)// Im Alter von 200 Runden stirbt ein Tier
	{
	//sterben
		[self TierStirbt:[Tiere objectAtIndex:TierID]];
	}
	else
	{
	//Entscheidungsprozess wird eingeleitet
		[self EntscheidungTier:gewaehltesTier];
	}
	
	return self;
}

- (void)TiereAussetzenSim:(int)Anzahl
{
	int v;
	for (v = 0; v < Anzahl; v++)
	{
		[Tiere addObject:[[Tier alloc] initMitVater:nil Mutter:nil]];
	}
}



//Abfragefunktionen
- (int)AnzahlTiere{return [Tiere count];}
- (id)TierMitID:(int)ID{return [Tiere objectAtIndex:ID];}
- (int)ProzessZaehler{return ProzessZaehler;}


//Prozesshilfsfunktionen
- (id)EntscheidungTier:(id)gewaehltesTier
{
	int StandortX = [gewaehltesTier StandortX];
	int StandortY = [gewaehltesTier StandortY];
	
	int TierID = [Tiere indexOfObjectIdenticalTo:gewaehltesTier];

	id zweitesTier = nil;
	
	int PunkteFuerTatUndZug[3][9];
			//0 = Fortpflanzung
			//1 = Essen
			//2 = Warten
			
	id moeglichesFeld[9];
	int Gesamtpunktzahl = 0;
	
	moeglichesFeld[0] = [[Felder objectAtIndex:StandortX-1] objectAtIndex:StandortY-1];
	moeglichesFeld[1] = [[Felder objectAtIndex:StandortX-1] objectAtIndex:StandortY+0];
	moeglichesFeld[2] = [[Felder objectAtIndex:StandortX-1] objectAtIndex:StandortY+1];
	moeglichesFeld[3] = [[Felder objectAtIndex:StandortX+0] objectAtIndex:StandortY-1];
	moeglichesFeld[4] = [[Felder objectAtIndex:StandortX+0] objectAtIndex:StandortY+0];
	moeglichesFeld[5] = [[Felder objectAtIndex:StandortX+0] objectAtIndex:StandortY+1];
	moeglichesFeld[6] = [[Felder objectAtIndex:StandortX+1] objectAtIndex:StandortY-1];
	moeglichesFeld[7] = [[Felder objectAtIndex:StandortX+1] objectAtIndex:StandortY+0];
	moeglichesFeld[8] = [[Felder objectAtIndex:StandortX+1] objectAtIndex:StandortY+1];

//Attraktivitt der verschiedenen Felder ermitteln
    int Nahrung1Parameter = [gewaehltesTier Nahrung1Parameter];
    int Nahrung2Parameter = [gewaehltesTier Nahrung2Parameter];
    int WartenParameter = [gewaehltesTier WartenParameter];
    int FortpflanzungParameter = [gewaehltesTier FortpflanzungParameter];
    int FortpflanzungEigeneArtParameter = [gewaehltesTier FortpflanzungEigeneArtParameter];
	int StehenBleibenBonus = [gewaehltesTier StehenBleibenBonus];
	for (v = 0; v < 9; v++)
	{
		zweitesTier = [moeglichesFeld[v] getTier];
		if (zweitesTier != nil && zweitesTier != gewaehltesTier && [zweitesTier Geschlecht] != [gewaehltesTier Geschlecht])
		{
	//Fortpflanzung
		//wenn eigene Art
			if (([gewaehltesTier Nahrung2Parameter] > [zweitesTier Nahrung2Parameter]*0.600 && [gewaehltesTier Nahrung2Parameter]*0.600 < [zweitesTier Nahrung2Parameter]) && ([gewaehltesTier Nahrung1Parameter] > [zweitesTier Nahrung1Parameter]*0.600 && [gewaehltesTier Nahrung1Parameter]*0.600 < [zweitesTier Nahrung1Parameter]))
			{
				PunkteFuerTatUndZug[0][v] = FortpflanzungEigeneArtParameter;
			}
		//wenn andere Art
			else
			{
				PunkteFuerTatUndZug[0][v] = FortpflanzungParameter;
			}
		}
		else
		{
			PunkteFuerTatUndZug[0][v] = 0;
		}
		
	//Essen
		//Wenn Nahrung1
		if([moeglichesFeld[v] Art] == 1)
		{
			PunkteFuerTatUndZug[1][v] = [moeglichesFeld[v] Beweidung] / 100 * Nahrung1Parameter;
		}
		//Wenn Nahrung2
		if([moeglichesFeld[v] Art] == 2)
		{
			PunkteFuerTatUndZug[1][v] = [moeglichesFeld[v] Beweidung] / 100 * Nahrung2Parameter;
		}
		//Wenn Rand
		if([moeglichesFeld[v] Art] == 3)
		{
			PunkteFuerTatUndZug[1][v] = 0;
		}
		
	//Warten
		PunkteFuerTatUndZug[2][v] = WartenParameter;		
	}
	
//Bonus fr Stehenbleiben verteilen
	for (v = 0; v < 4; v++)
	{
		PunkteFuerTatUndZug[v][4] = PunkteFuerTatUndZug[v][4] + StehenBleibenBonus;
	}
	
//Gesamtpunktzahl berechnen
	for (v = 0; v < 9; v++)
	{
		for (w = 0; w < 3; w++)
		{
			Gesamtpunktzahl = Gesamtpunktzahl + PunkteFuerTatUndZug[w][v];
		}
	}

//Wahl treffen
	if (Gesamtpunktzahl > 0)
	{
		Rand = rand()%Gesamtpunktzahl;
		int bisherigePunkte = 0;
		int GesamtpunkteFuerZug[9];
		
	//Gesamtpunktzahlen fr die einzelnen Zge (ohne Taten) berechnen
		for (v = 0; v < 9 ; v++)
		{
			GesamtpunkteFuerZug[v] = PunkteFuerTatUndZug[0][v] + PunkteFuerTatUndZug[1][v] + PunkteFuerTatUndZug[2][v];
		}
		
	//Wahl zufllig ermitteln
		//Standardmssig Warten:
		int TatID = 2;

		if (Rand < GesamtpunkteFuerZug[0])
		{
			Rand = rand()%GesamtpunkteFuerZug[0];
			
			if (Rand < PunkteFuerTatUndZug[0][0])
			{
				TatID = 0;
			}
			else
			{
				if (Rand < PunkteFuerTatUndZug[1][0] + PunkteFuerTatUndZug[0][0])
				{
					TatID = 1;
				}
			}
			
			[self Tier:gewaehltesTier willTun:TatID mitBewegungUmX:-1 UmY:-1];
			return self;
		}
		bisherigePunkte += GesamtpunkteFuerZug[0];
		
		if (Rand < (bisherigePunkte + GesamtpunkteFuerZug[1]))
		{
			Rand = rand()%GesamtpunkteFuerZug[1];

			if (Rand < PunkteFuerTatUndZug[0][1])
			{
				TatID = 0;
			}
			else
			{
				if (Rand < PunkteFuerTatUndZug[1][1] + PunkteFuerTatUndZug[0][1])
				{
					TatID = 1;
				}
			}
			
			[self Tier:gewaehltesTier willTun:TatID mitBewegungUmX:-1 UmY:0];
			
			return self;
		}
		bisherigePunkte += GesamtpunkteFuerZug[1];
		
		if (Rand < (bisherigePunkte + GesamtpunkteFuerZug[2]))
		{
			Rand = rand()%GesamtpunkteFuerZug[2];

			if (Rand < PunkteFuerTatUndZug[0][2])
			{
				TatID = 0;
			}
			else
			{
				if (Rand < PunkteFuerTatUndZug[1][2] + PunkteFuerTatUndZug[0][2])
				{
					TatID = 1;
				}
			}
			
			[self Tier:gewaehltesTier willTun:TatID mitBewegungUmX:-1 UmY:1];
			
			return self;
		}
		bisherigePunkte += GesamtpunkteFuerZug[2];
		
		if (Rand < (bisherigePunkte + GesamtpunkteFuerZug[3]))
		{
			Rand = rand()%GesamtpunkteFuerZug[3];

			if (Rand < PunkteFuerTatUndZug[0][3])
			{
				TatID = 0;
			}
			else
			{
				if (Rand < PunkteFuerTatUndZug[1][3] + PunkteFuerTatUndZug[0][3])
				{
					TatID = 1;
				}
			}
			
			[self Tier:gewaehltesTier willTun:TatID mitBewegungUmX:0 UmY:-1];
			
			return self;
		}
		bisherigePunkte += GesamtpunkteFuerZug[3];
		
		if (Rand < (bisherigePunkte + GesamtpunkteFuerZug[4]))
		{
			Rand = rand()%GesamtpunkteFuerZug[4];

			if (Rand < PunkteFuerTatUndZug[0][4])
			{
				TatID = 0;
			}
			else
			{
				if (Rand < PunkteFuerTatUndZug[1][4] + PunkteFuerTatUndZug[0][4])
				{
					TatID = 1;
				}
			}
			
			[self Tier:gewaehltesTier willTun:TatID mitBewegungUmX:0 UmY:0];
			
			return self;
		}
		bisherigePunkte += GesamtpunkteFuerZug[4];
		
		if (Rand < (bisherigePunkte + GesamtpunkteFuerZug[5]))
		{
			Rand = rand()%GesamtpunkteFuerZug[5];

			if (Rand < PunkteFuerTatUndZug[0][5])
			{
				TatID = 0;
			}
			else
			{
				if (Rand < PunkteFuerTatUndZug[1][5] + PunkteFuerTatUndZug[0][5])
				{
					TatID = 1;
				}
			}
			
			[self Tier:gewaehltesTier willTun:TatID mitBewegungUmX:0 UmY:1];
			
			return self;
		}
		bisherigePunkte += GesamtpunkteFuerZug[5];
		
		if (Rand < (bisherigePunkte + GesamtpunkteFuerZug[6]))
		{
			Rand = rand()%GesamtpunkteFuerZug[6];

			if (Rand < PunkteFuerTatUndZug[0][6])
			{
				TatID = 0;
			}
			else
			{
				if (Rand < PunkteFuerTatUndZug[1][6] + PunkteFuerTatUndZug[0][6])
				{
					TatID = 1;
				}
			}
			
			[self Tier:gewaehltesTier willTun:TatID mitBewegungUmX:1 UmY:-1];
			
			return self;
		}
		bisherigePunkte += GesamtpunkteFuerZug[6];
		
		if (Rand < (bisherigePunkte + GesamtpunkteFuerZug[7]))
		{
			Rand = rand()%GesamtpunkteFuerZug[7];

			if (Rand < PunkteFuerTatUndZug[0][7])
			{
				TatID = 0;
			}
			else
			{
				if (Rand < PunkteFuerTatUndZug[1][7] + PunkteFuerTatUndZug[0][7])
				{
					TatID = 1;
				}
			}
			
			[self Tier:gewaehltesTier willTun:TatID mitBewegungUmX:1 UmY:0];
			
			return self;
		}
		
		Rand = rand()%GesamtpunkteFuerZug[8];

			if (Rand < PunkteFuerTatUndZug[0][8])
			{
				TatID = 0;
			}
			else
			{
				if (Rand < PunkteFuerTatUndZug[1][8] + PunkteFuerTatUndZug[0][8])
				{
					TatID = 1;
				}
			}
		
		[self Tier:gewaehltesTier willTun:TatID mitBewegungUmX:1 UmY:1];
		
		return self;
	}
	
//Wenn die Gesamtpunktzahl < 1 ist
	else
	{
		[self Tier:gewaehltesTier willTun:2 mitBewegungUmX:0 UmY:0];
	}

	return self;
}

- (id)Tier:(id)gewaehltesTier willTun:(int)TatID mitBewegungUmX:(int)VerschiebungX UmY:(int)VerschiebungY
{
//die verschiedenen TatIDs:
	int Fortpflanzung = 0;
	int Essen = 1;
	int Warten = 2;
	
	int alterStandortX = [gewaehltesTier StandortX];
	int alterStandortY = [gewaehltesTier StandortY];
//neuer Standort bleibt vorerst noch alter, denn vielleicht ist Bewegung ungltig (z.B. auf Wasser)
	int neuerStandortX = alterStandortX;
	int neuerStandortY = alterStandortY;
	
	id WunschZielFeld = [[Felder objectAtIndex:alterStandortX+VerschiebungX] objectAtIndex:alterStandortY+VerschiebungY];
	
	id zweitesTier = [WunschZielFeld getTier];

//Bewegung
//Wenn WunschZielFeld nicht erreicht werden kann
	if ([WunschZielFeld Art] == 3)
	{
		[[[Felder objectAtIndex:alterStandortX] objectAtIndex:alterStandortY] neuesTier:gewaehltesTier];
		[gewaehltesTier Energieabnahme:30];
	}
	else
	{
		if (VerschiebungX != 0 && VerschiebungY != 0)	//Wenn nicht gleich Wasser; wenn nicht gleich keine Bewegung
		{
		//Energie fr Bewegung
			[gewaehltesTier Energieabnahme:30];
		//Bewegung ausfhren
			[gewaehltesTier StandortWechselX:VerschiebungX WechselY:VerschiebungY];
			neuerStandortX = [gewaehltesTier StandortX];
			neuerStandortY = [gewaehltesTier StandortY];
		}

		id neuesFeld = [[Felder objectAtIndex:neuerStandortX] objectAtIndex:neuerStandortY];
		
	//sich vom alten Feld entfernen
		[[[Felder objectAtIndex:alterStandortX] objectAtIndex:alterStandortY] neuesTier:nil];
	//sich beim neuen Feld registrieren
		[neuesFeld neuesTier:gewaehltesTier];
		
		if ([gewaehltesTier SchonAktivitaet] == YES)
		{
			[gewaehltesTier SchonAktivitaetAendern];
		}
		else
		{
	//Aktivitten
		//Fortpflanzung
			if (TatID == Fortpflanzung)
			{
				
			//Bedingungen fr Fortpflanzung mit anderem Tier
				if (zweitesTier != nil && zweitesTier != gewaehltesTier/* && ![zweitesTier gestorben]*/
					&& /*selbe Art:*/ (([gewaehltesTier Nahrung2Parameter] > [zweitesTier Nahrung2Parameter]*0.600 && [gewaehltesTier Nahrung2Parameter]*0.600 < [zweitesTier Nahrung2Parameter]) && ([gewaehltesTier Nahrung1Parameter] > [zweitesTier Nahrung1Parameter]*0.600 && [gewaehltesTier Nahrung1Parameter]*0.600 < [zweitesTier Nahrung1Parameter]))
					&& [zweitesTier SchonAktivitaet] == NO
					&& [zweitesTier Geschlecht] != [gewaehltesTier Geschlecht])
				{
					[gewaehltesTier Energieabnahme:100];//30];
					[Tiere addObject:[[Tier alloc] initMitVater:gewaehltesTier Mutter:zweitesTier]];
					[zweitesTier SchonAktivitaetAendern];
					[zweitesTier Energieabnahme:100];//200];
				}
			}
		
		//Essen
			if (TatID == Essen)
			{
				[gewaehltesTier Energieabnahme:30];
				
				if ([neuesFeld Nutzung] == YES)
				{
					if ([neuesFeld Art] == 1)
					{
						[gewaehltesTier Essen:(float)[gewaehltesTier Nahrung1Anpassung]/5]; //soll etwa 100 geben
					}
					if ([neuesFeld Art] == 2)
					{
						[gewaehltesTier Essen:(float)[gewaehltesTier Nahrung2Anpassung]/5]; //soll etwa 100 geben; kleiner Bonus fr Nahrung2
					}
				}
			}
		//Warten geschieht, wenn nicht Essen oder Fortpflanzung
		}
	}

	return self;
}
- (id)TierStirbt:(id)TierID
{
	id myFeld = [[Felder objectAtIndex:[TierID StandortX]] objectAtIndex:[TierID StandortY]];
	[myFeld neuesTier:nil];
	//soll: ist das in 0.2.0 immer noch ntig?:
/*	if ([Tiere indexOfObjectIdenticalTo:TierID] != NSNotFound)
	{*/				//billige Lsung fr Bug; sollte noch besser werden
		[Tiere removeObjectAtIndex:[Tiere indexOfObjectIdenticalTo:TierID]];
//	}
	return self;
}

/*- (id)TierStirbt:(int)ID
{
	id gewaehltesTier = [self TierMitID:ID];
	[gewaehltesTier sterben];
	id myFeld = [[Felder objectAtIndex:[gewaehltesTier StandortX]] objectAtIndex:[gewaehltesTier StandortY]];
	[myFeld neuesTier:nil];
	[Tiere removeObjectAtIndex:ID];
	return self;
}
*/

@end
